Index: examples/fruits_rt2_typed/Bob_ID.pem
===================================================================
--- examples/fruits_rt2_typed/Bob_ID.pem	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
+++ examples/fruits_rt2_typed/Bob_ID.pem	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
@@ -0,0 +1,19 @@
+-----BEGIN CERTIFICATE-----
+MIIDATCCAemgAwIBAgIIWkL6r8NfGgowDQYJKoZIhvcNAQEFBQAwDjEMMAoGA1UE
+AxMDQm9iMB4XDTEyMDIyMzIxMzgwOFoXDTE1MDIwNzIxMzgwOFowDjEMMAoGA1UE
+AxMDQm9iMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA4iit2BqTZUKe
+AYq2wD2CieIvU7QTWfZXnqd653QLg7CSSMTVZvqOdpA4DYOsje11mE4DEOOq+y7V
+SZqY0VZ+0XGRf9vElyPbZcS6yUqVgPtY14cfXEQk7EA5vOOwI7iw46Weg/Fz2XmT
+ox7JTx3cSFKRDjEDg2dStRaFi2FTKv19vtZQMya76rJ78QHe3vM7ReKj7SmaFGRt
+3XJxd+818SBGRqOdD81EiZDw857WmYa43R+7nG1/uwh6IAtvW7xcbeUwBSFpISHE
+p0XHXeKVP1RK8o5AqIlZg7xmIfW7AqLEntBvSuZ7mFT4yA45rgJddqTuCVd3t7j+
+xjK+0IjPXQIDAQABo2MwYTAPBgNVHRMBAf8EBTADAQH/MA4GA1UdDwEB/wQEAwIB
+BjAdBgNVHQ4EFgQU3HFrd0VimD98lYUdIOgdWWYidUUwHwYDVR0jBBgwFoAU3HFr
+d0VimD98lYUdIOgdWWYidUUwDQYJKoZIhvcNAQEFBQADggEBAGr0sMKtY+SY7+xA
+kKWFzng+aYZVQulVMeepcTP76yYfvXBwdwgwb77evUZhZ2eoGF2lGxHcTaPjctlN
+TsXSBX9T0blQ9cLnyTeQMXHrBxyItZqxL6ZQzjOTei6q1XQhJogLwuRfAiikJiFU
+19x4fNPBMhyed35xpxdR8tnpcfKh67OWLxeVlsokZ2VRmd8cJHR4cZSHrcS6A6oM
+cPf44u8r8r406/RuXl48T++k5BfhBWIxbKApMo+3tJ8AoTKywYu4GI4zTjGJ1rYo
+TSX9xEendaq3nEdkywZ7rR1e3xIqMQA7p0BaKXCBaa6PVbH8NQpOF7o3blfswdoT
+LVK+C3g=
+-----END CERTIFICATE-----
Index: examples/fruits_rt2_typed/Bob_private.pem
===================================================================
--- examples/fruits_rt2_typed/Bob_private.pem	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
+++ examples/fruits_rt2_typed/Bob_private.pem	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
@@ -0,0 +1,27 @@
+-----BEGIN RSA PRIVATE KEY-----
+MIIEpQIBAAKCAQEA4iit2BqTZUKeAYq2wD2CieIvU7QTWfZXnqd653QLg7CSSMTV
+ZvqOdpA4DYOsje11mE4DEOOq+y7VSZqY0VZ+0XGRf9vElyPbZcS6yUqVgPtY14cf
+XEQk7EA5vOOwI7iw46Weg/Fz2XmTox7JTx3cSFKRDjEDg2dStRaFi2FTKv19vtZQ
+Mya76rJ78QHe3vM7ReKj7SmaFGRt3XJxd+818SBGRqOdD81EiZDw857WmYa43R+7
+nG1/uwh6IAtvW7xcbeUwBSFpISHEp0XHXeKVP1RK8o5AqIlZg7xmIfW7AqLEntBv
+SuZ7mFT4yA45rgJddqTuCVd3t7j+xjK+0IjPXQIDAQABAoIBAQDcvbXI60+Yk2gj
+ux/bDW5/ZJyrB2Wn9lDZU0Eb7mFavRpbGnvsknxA7002q6HdubuA2AwYDQ+TMcgO
+mm20TcdkaIQKlxgQKXh4oYdq93hrN2kknQeYCA895QY1/sqqYxeMatgIksBvsUHQ
+AjmdFlku4iAhCOgT9uJ8TCo2u9zwZDvHvO0YgywsP4BH2HWqDBm8SasUq9Jg05st
+kmg3oGxaxes7DY6tf1CACZeVzCKDVCLIG2x/CE3OHdS0oXtNCwazQRAkT+Eeol5w
+37wbUPjpE4bLR9TG2tY9VHkTz/79U9Jr8G43Y0nFa+6ZKos1k5/BunW+5cLt4G+D
+NjAKLH3lAoGBAPhgfN0cvxcaryXb8zy00cDT9Ai6/T5Z/M8bOGUzpR4TkQfrWCiT
+8YGsEgGcov9OzeEW1D43wbrWPBnReThIpb2NHI6z6GjdSHzlsdaZ07EjDnANXw9U
+llKtn0W6/LNp81YzPYQ2/phDEl1QwzQR95MindM7ahQNUH0wvY3dv8oXAoGBAOkZ
+n4a/doRIN2CBmSF+AMIf3DD2vzzjwAmoOBBRE9ROS+zDPb6505CiR+uJSGYzIJV7
+wnb54nxpItNTCmvgLULlw2LHj0F7CQZNK05+dT0qBrYFYOHP6zXWALv7N4fbdeDv
+q6ymebHPBSjWp1YEvaUt/spfncwGYNEQ814Epv6rAoGAaoeP5pJmz3UNfFJ7YCU5
+9deyym/RIIYeLYJCTP26q0y/HsNtO3JA2lpAGtrg+loFaa6N9+WYPReYDYbP1Dks
+hUFZ50b4vslyRseJ4D54Enizv5GsnPmtw+Zd8t2Bdz5RNT6i+utPhWT3Inj6UIII
+St5FDQ1lsRYI2LkoBAoBMZ8CgYEA0+MzzLP8ErDmjbYgsX4tSEjXyjZxjfLlHKIq
+HELnCIUHpTewx895Ti8Fu0g2ZJgzFU7DbY0mYLrdKkWA4qCL5BShcAhA41/oyy6Y
+oCh5f9jU8t6eu4VZpL1cO4RXbQqD861JW46UbpnlccL1p0516VGPGvyhntVpaoHD
+B4KpHjMCgYEAh5oWWgYKLsRFK6R5O1fP0RINuIHsyf/xrtkgAgQZbVH43zSrBCHK
+l5vN0ytlgI/goCQj2CrqlHxx9L4YXN/6dDZOa+MLW6qo/u1vAbaatWk47JXO37K5
+L/D25Q9NgeGj74Sjv8Cx1hbBzHbWEltyPcl8Ttx/qHSmdcR8WYnMTN0=
+-----END RSA PRIVATE KEY-----
Index: examples/fruits_rt2_typed/Mary_ID.pem
===================================================================
--- examples/fruits_rt2_typed/Mary_ID.pem	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
+++ examples/fruits_rt2_typed/Mary_ID.pem	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
@@ -0,0 +1,19 @@
+-----BEGIN CERTIFICATE-----
+MIIDAzCCAeugAwIBAgIIbYwRT/4GXEswDQYJKoZIhvcNAQEFBQAwDzENMAsGA1UE
+AxMETWFyeTAeFw0xMjAyMjMyMTM4MDVaFw0xNTAyMDcyMTM4MDVaMA8xDTALBgNV
+BAMTBE1hcnkwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQC7wmD3vMOe
+3pwwho9jAclEWHk4lidmO5ipQhkTjQ0iVZ32AKKm4YlGuB/RC6AcAJFsKy/MP8KF
+Mn0mYyqEL1sdIa5NQFHzus2XTMsHb8phT3D1Bm9cPb/uo6EmwkH5ZBUW7ECj8bjL
+4zwmEVoKkx/DnION9pXvzZGFOUGqHzke+0zVTTb+pVZhi9zFbmn9Vb623sWy+/tl
+Hj9eo9A5ScRkpMd8+aJ7R3c80Jr0Rd8t7pKqEnBg81IkDidmE9ppyVE3786wypY7
+jZb19aR1j8ln4SzhX1JuZur5VIVLscYkNwr7YjZ2UAPsAvrB+ibl8+xHNHteaGRM
+3QGydCnRWSqHAgMBAAGjYzBhMA8GA1UdEwEB/wQFMAMBAf8wDgYDVR0PAQH/BAQD
+AgEGMB0GA1UdDgQWBBQQl44RbkI+26xmLYDCfVmEP5N2VjAfBgNVHSMEGDAWgBQQ
+l44RbkI+26xmLYDCfVmEP5N2VjANBgkqhkiG9w0BAQUFAAOCAQEAE2EZ/xkrUx8V
+M2fZQosM3w7GmqFgz4rQtG74vjC2T0P98FYGwzXuSHaBRvyME88sPEnobnjoR++Q
+qnru9PBRPgFxcFv0wS773Y+jBnwYQ4hSI7cAdZOTM42qczVZmAZD9eBXw0KpkCvY
+J8Zob3zy9Quh4X3vYtoMQAYG56tL0oPpZVZgOIZJTUD7XUWM73jk5Yob1ejhCmfY
+4skop2LYfdwYHKDFg3guTkr9s3YAvfnvSFmeY2E9l/hxg1NetMnulR61jkGGdKIt
+U+s8+SVkzzEbdKBN+SiKmE+GS6Z/BdJTEW7ll9M3KHEaZ/KjJKKAUjEHk0jdCncI
+Xr+Vg365+w==
+-----END CERTIFICATE-----
Index: examples/fruits_rt2_typed/Mary_private.pem
===================================================================
--- examples/fruits_rt2_typed/Mary_private.pem	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
+++ examples/fruits_rt2_typed/Mary_private.pem	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
@@ -0,0 +1,27 @@
+-----BEGIN RSA PRIVATE KEY-----
+MIIEpAIBAAKCAQEAu8Jg97zDnt6cMIaPYwHJRFh5OJYnZjuYqUIZE40NIlWd9gCi
+puGJRrgf0QugHACRbCsvzD/ChTJ9JmMqhC9bHSGuTUBR87rNl0zLB2/KYU9w9QZv
+XD2/7qOhJsJB+WQVFuxAo/G4y+M8JhFaCpMfw5yDjfaV782RhTlBqh85HvtM1U02
+/qVWYYvcxW5p/VW+tt7Fsvv7ZR4/XqPQOUnEZKTHfPmie0d3PNCa9EXfLe6SqhJw
+YPNSJA4nZhPaaclRN+/OsMqWO42W9fWkdY/JZ+Es4V9Sbmbq+VSFS7HGJDcK+2I2
+dlAD7AL6wfom5fPsRzR7XmhkTN0BsnQp0VkqhwIDAQABAoIBACBYWhATirehrdKG
+O8lYk22cuDVRWLQ57BCsfFlr4SlbCn1ImryY+ece7Qw8LnbkeijiP7e1/DKqAflM
++BQRfGbGWJqiS/vq4GQCLK+5SGn/H3x2gVSoppnbwnVE3cyyuxdZ18DmcWleWgxM
+zPApbD1shxU7t5S6GymSNYezHUoCwSmZqY5rdgStCl2+IxwMLn3QCh6kUyZ9a3xZ
++KFPq9dGLECHyS4Sit40eOnTShv3pqYiEJ7La/dCzuYBxwHD9kcIdLcWW6VhYUOW
+JXYHacDumCopTCJJ13ev0JahszRx4JHy9RyYhiIXhu2eR3jf4TWG2KiWk2KWKlA3
+JxUJQeECgYEA3/nwGfmsZhLcRSwIwIebdmtBJDJaJefKsGzba5ZKTgM/vOwSmAtO
+ejCGPUPnYzKDOHeWTuuYQrlw/ibxh9ysTUrnxuqbV8xuZQ0lzHGBR5CA4Mg3YnBd
+/Qx/9HhL6pwq4gzjdSDIbXktKJ6HZCWvtW3Ray2328upMvTrtEwB228CgYEA1prP
+6boTo8yNmfwoX/0oj6F/EQw1f3FAGpT2w4ZgE6190COy/FY4XcMn9yVpmLSWmiU5
+/laP68GINLOfX9lerlQBGPjcglQpKEX5ULAYIFTOViYXyUXen53Y3iMdzOFRHTCg
+PqVaiesFJJqZsQnWsUMNB8SXxdYyvn8ZL7kfdmkCgYEAwisccnhXc7ogCTuObtJg
+/P0oYOfh7QCQX/hPFGsbCZyZcf+6cuNCan2Msqoee4m75oUN4mct/ZJkGYDLXPv6
+x5sLag/TEf9hKOuH/D/eUps8jyIjmYxOfuSKPPbY4Y/3QTbpLY55Eya89nzQZQqi
+1AdbSK4+uSZLDaj0eb520bMCgYEAy4lm+gkWiXr/LfV/IZMMfjUwO631q1pw7wUr
+iUQQKXmZYugI4NSxfxQR+pBMN53HXIlEGJpmw7X5Ber6lECoUPSxWcrl8OH7awv6
+qvFo4HkufXyBgM64l3Bw+DYcFG36rZGp2eCgH0B8zzul2sg3DEZIvH5TaDqARDZt
+X9rXIUkCgYB6OqoQ4+3MAjJYTaxleZ581YX7g0j7uNyoiQmT8/PKbDk4UTwRxLZ0
+Wf+RxzDik8sd3jW/r28FgQSUKOcBcvTHaWDq6beVr600Uy1/iOWlt9PJCRlawnI4
+TmH/wCdybenw45pcM7VQAtWkznFlgHd25vKV/DObedhvF/LIQ4waaQ==
+-----END RSA PRIVATE KEY-----
Index: examples/fruits_rt2_typed/README
===================================================================
--- examples/fruits_rt2_typed/README	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
+++ examples/fruits_rt2_typed/README	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
@@ -0,0 +1,73 @@
+#!/bin/sh
+
+rm -rf *.der *.pem
+
+# mary.what2eat<-?-orange  good
+# bob.what2eat<-?-orange  bad
+# ralphs.fruitprice(1.50)<-?-apple good
+
+creddy --generate --cn Mary
+creddy --generate --cn Bob
+creddy --generate --cn Ralphs
+
+mary_keyid=`creddy --keyid --cert Mary_ID.pem`
+bob_keyid=`creddy --keyid --cert Bob_ID.pem`
+ralphs_keyid=`creddy --keyid --cert Ralphs_ID.pem`
+
+fruitprice_qP="fruitprice([float:?P:[..2.00]])"
+fruitprice_qP_2="fruitprice([float:?P:[1.00..5.00]])"
+
+# [keyid:mary].oset:what2eat 
+#      <- [keyid:ralphs].oset:fruitprice([float:?P:[..2.00]])
+creddy --attribute \
+       --issuer Mary_ID.pem --key Mary_private.pem --oset "what2eat" \
+       --subject-cert Ralphs_ID.pem --subject-oset "$fruitprice_qP" \
+       --out mary_what2eat__ralphs_fruitprice_qP_attr.der
+
+# [keyid:bob].oset:what2eat 
+#      <- [keyid:ralphs].oset:fruitprice([float:?P:[1.00..5.00]])
+creddy --attribute \
+       --issuer Bob_ID.pem --key Bob_private.pem --oset "what2eat" \
+       --subject-cert Ralphs_ID.pem --subject-oset "$fruitprice_qP_2" \
+       --out bob_what2eat__ralphs_fruitprice_qP_2_attr.der
+
+# [keyid:ralphs].oset:fruitprice([float:1.50]) <- [string:'apple']
+creddy --attribute \
+        --issuer Ralphs_ID.pem --key Ralphs_private.pem \
+        --oset "fruitprice([float:1.50])" \
+        --subject-obj "[string:'apple']" \
+        --out Ralphs_fruitprice__apple_attr.der
+
+# [keyid:ralphs].oset:fruitprice([float:2.50]) <- [string:'blueberry']
+creddy --attribute \
+        --issuer Ralphs_ID.pem --key Ralphs_private.pem \
+        --oset "fruitprice([float:2.50])" \
+        --subject-obj "[string:'blueberry']" \
+        --out Ralphs_fruitprice__blueberry_attr.der
+
+# [keyid:ralphs].oset:fruitprice([float:0.50]) <- [string:'orange']
+creddy --attribute \
+        --issuer Ralphs_ID.pem --key Ralphs_private.pem \
+        --oset "fruitprice([float:0.50])" \
+        --subject-obj "[string:'orange']" \
+        --out Ralphs_fruitprice__orange_attr.der
+
+#####################################################################
+# mary.what2eat <- ralphs.fruitsprice(?P:[..2.00])
+# [keyid:mary].oset:what2eat 
+#      <- [keyid:ralphs].oset:fruitprice([float:?P:[..2.00]])
+#
+# bob.what2eat <- ralphs.fruitsprice(?P:[1.00..5.00])
+# [keyid:bob].oset:what2eat 
+#      <- [keyid:ralphs].oset:fruitprice([float:?P:[1.00..5.00]])
+# 
+# ralphs.fruitprice(1.50)<-apple
+# [keyid:ralphs].oset:fruitprice([float:1.50]) <- [string:'apple']
+#
+# ralphs.fruitprice(2.50)<-blueberry
+# [keyid:ralphs].oset:fruitprice([float:2.50]) <- [string:'blueberry']
+#
+# ralphs.fruitprice(0.50)<-orange
+# [keyid:ralphs].oset:fruitprice([float:0.50]) <- [string:'orange']
+# 
+
Index: examples/fruits_rt2_typed/Ralphs_ID.pem
===================================================================
--- examples/fruits_rt2_typed/Ralphs_ID.pem	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
+++ examples/fruits_rt2_typed/Ralphs_ID.pem	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
@@ -0,0 +1,19 @@
+-----BEGIN CERTIFICATE-----
+MIIDBzCCAe+gAwIBAgIIYryTFCPXkJowDQYJKoZIhvcNAQEFBQAwETEPMA0GA1UE
+AxMGUmFscGhzMB4XDTEyMDIyMzIxMzgwOVoXDTE1MDIwNzIxMzgwOVowETEPMA0G
+A1UEAxMGUmFscGhzMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAzcTZ
+TIgPzIQuCvOMbIey9eUflJIl5nwhOLHNCUrRB2vEkAXkmzXAq9MpQv+xeWj/jeVw
+CnikZIM2TtIzM37NW8E5HNUnBK1NyZISzVs67rU8EDOOohZdjbvabvTHfTZHo3Gl
+ndO5HvflY/reYKPrCFv/iQ+0I/t6aRDJQ8jmTux0tJTaPZ5AujcVsy5nlOh7P68+
+WcIlEVfQ0yMZhc3RF6CLg0dSKLAGHj/Io9cZdaMxgW0gCRwlsEq4gR+U8Ltv3NTH
+F2X20WxiAjILTNAa1pOhOvDgzbkb3yVgx5kbvwLUtPhvQtBc5QUnb8Sx1Za+eyAs
+UBZ//NhjArHdJ54zmwIDAQABo2MwYTAPBgNVHRMBAf8EBTADAQH/MA4GA1UdDwEB
+/wQEAwIBBjAdBgNVHQ4EFgQULoSbLwACRtFUnEGiFY0TVNLbI3AwHwYDVR0jBBgw
+FoAULoSbLwACRtFUnEGiFY0TVNLbI3AwDQYJKoZIhvcNAQEFBQADggEBAHWtvgmV
+ZuEM8TAPo/8i/Zvb5BNHDwlKW5NBNlKntQUIKeQ4yTMe1WXuYzkw8h5wIznGostf
+oTqC9Rtpwu9nxPJvJkszXP92+zGZ9chjCIrbqeAbZLtcTyeO0khpd2pBmtH6P9Zc
+uXDYVQSHu0+j7cM6Sgfrt390z0l0ptV8x1NwwJzRdS5u6i6N36D2IcFnBe8bBB45
+mVboNh0SqoFfwlye54Zq4qDL7ORlnYiftrAkNsNqeTYs/t596kaK2AS6pUVUNhOO
+UUXHICCs1FM57Wk8SYxNZXbYFQyvI9vROUCh58CTfcL2x+AJvYO4fM/r94NGPaic
+wwbOknPHiCIi2J8=
+-----END CERTIFICATE-----
Index: examples/fruits_rt2_typed/Ralphs_private.pem
===================================================================
--- examples/fruits_rt2_typed/Ralphs_private.pem	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
+++ examples/fruits_rt2_typed/Ralphs_private.pem	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
@@ -0,0 +1,27 @@
+-----BEGIN RSA PRIVATE KEY-----
+MIIEowIBAAKCAQEAzcTZTIgPzIQuCvOMbIey9eUflJIl5nwhOLHNCUrRB2vEkAXk
+mzXAq9MpQv+xeWj/jeVwCnikZIM2TtIzM37NW8E5HNUnBK1NyZISzVs67rU8EDOO
+ohZdjbvabvTHfTZHo3GlndO5HvflY/reYKPrCFv/iQ+0I/t6aRDJQ8jmTux0tJTa
+PZ5AujcVsy5nlOh7P68+WcIlEVfQ0yMZhc3RF6CLg0dSKLAGHj/Io9cZdaMxgW0g
+CRwlsEq4gR+U8Ltv3NTHF2X20WxiAjILTNAa1pOhOvDgzbkb3yVgx5kbvwLUtPhv
+QtBc5QUnb8Sx1Za+eyAsUBZ//NhjArHdJ54zmwIDAQABAoIBAHvo41XzxVfJ7RQJ
+L3GXkcwDaq4ECDCwZS0H3MmQtSk720VDVzOj/d86rGk9InlTIjknhf24Qn6IiSaT
+6+NBo5ZyV9sl/HYTinksrofdPTLMDlxPP8AZqcKU8efJHWwoSKGC6VGOUrb0Xr2D
+L3CQpRMGm23E+ByG7mLgieJ40z+IjZ3DXtTsLpUxL8BUGwiE9pQSTR6QWSY87pR4
+fMcsu86rUxrRTKuPTh0mHcwZ2Ngl+/GTqjYTE2pC8cJt9PiMzYR6ojHkWuOJrwHO
+nqUgszP2Jd+/vAkwIuSb2avtAZssl8/HSDoEeEKIGJVypEvVzI+tdu/vQfQ5IMUi
+nNKdjgECgYEA880PtM21Vp9UVlwDw55zv6fHCnYFqD5EMlDCv6yEuncxCob6BpUm
+q/v1Z7p4OgAZALsbUt3PqF+NUh2agHEoT89VMMgVuup9lV0c/YT/L8TBD1AVqzHU
+6JSHPiUUFbJ8Ati7K7l+ARP65o5/qJiCms8WKXR7qcV2nGo5ho94KwECgYEA2BCe
+zCoZZlSekMF3Th6Ooj/X874ub5Z1E9ODKEXMmDdyTRWFFASjzPxPHuhLzVrIdNLa
+wFViDghnVV8d/xG8YWyqJ8dLouSgVP5NtnbBWrcnocc4due6HR1pxA8wG8WcsXaI
+ZLiCJRMk8hnpHSZchcSppXchUIVlzdiYf/jOKpsCgYEA3EDKyrX4+HvSzn4sbGLP
+ATuK5xl+vOMb6zTo7A7ojii2JmOQp7fBiyiCKSbeDNAfxnhDFBcNzngcjS3vcdBI
+8elGdl6cuxOzRugrE6I+hKJFJBderB3F0iS1FeCbh4qK3Gt+lN7sRf8N8ZKVI/Q8
+Ma2awPLZ8aNSJ7cTp0wf7QECgYAjWUTBnjmdlkaC5EQCkdlADjXkeL7cHr90yOvy
+UMkSNjALEHQ/PCsYREclhVexdyLIih6jzNRH+3P8cZ1Ut7AcOEz2SRLEyaa5gQlx
+yqgDkWd4fkFsoqi+TquZGesDACeMmRnjcJRKQIGQ4lBTJo2IjQ48NetLYyeur7rz
+ZN9F9QKBgHJoDXADmaYljLGvkGtmBc6vJormxxCbb0WoFo3OP/TB2H35MQDS9hZ+
+Njn3pCzfvRi5vDwR7aBoISZTwgczjSd+lxUhr3LR+rlX5TPDNi1m0G0ar21DDsoi
+0DnQ9efjltr2CXFt5/k2eMSG/5d1xD0Hl7Ay9MhvJ3Qz4I7ja+vd
+-----END RSA PRIVATE KEY-----
Index: examples/fruits_rt2_typed/creds_dump
===================================================================
--- examples/fruits_rt2_typed/creds_dump	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
+++ examples/fruits_rt2_typed/creds_dump	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
@@ -0,0 +1,5 @@
+ pRalphs.fruitprice(1.50) <- 'apple'
+ pRalphs.fruitprice(2.50) <- 'blueberry'
+ pRalphs.fruitprice(0.50) <- 'orange'
+ pBob.what2eat <- pRalphs.fruitprice(P:[1.00..5.00])
+ pMary.what2eat <- pRalphs.fruitprice(P:[..2.00])
Index: examples/fruits_rt2_typed/rr
===================================================================
--- examples/fruits_rt2_typed/rr	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
+++ examples/fruits_rt2_typed/rr	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
@@ -0,0 +1,33 @@
+rm -rf creds_dump
+
+pwd=`pwd`
+
+#eloc=/home/mei/Deter/abac/libabac
+eloc=$pwd/../../libabac
+#keyloc=/home/mei/Deter/abac/examples/fruits_rt2_typed
+keyloc=$pwd
+
+ralphs=`creddy --keyid --cert $keyloc/Ralphs_ID.pem`
+bob=`creddy --keyid --cert $keyloc/Bob_ID.pem`
+mary=`creddy --keyid --cert $keyloc/Mary_ID.pem`
+
+mary_what2eat="[keyid:$mary].oset:what2eat"
+bob_what2eat="[keyid:$bob].oset:what2eat"
+ralphs_apple="[keyid:$ralphs].oset:fruitprice([float:1.50])"
+
+## dump all credentials
+$eloc/abac_prover_yap  --keystore $keyloc --dump creds_dump
+
+# [keyid:mary].oset:what2eat <-?- [string:'orange'] (yes)
+echo "===good============ mary.what2eat <- orange yap "
+$eloc/abac_prover_yap  --keystore $keyloc --oset "$mary_what2eat" --object "[string:'orange']"
+
+# [keyid:bob].oset:what2eat <-?- [string:'orange'] (no)
+echo "===bad============ bob.what2eat <- orange yap "
+$eloc/abac_prover_yap  --keystore $keyloc --oset "$bob_what2eat" --object "[string:'orange']"
+
+# [keyid:$ralphs].oset:fruitprice([float:1.50]) <-?- [string:'apple'] (yes)
+echo "===good============ ralphs.fruitprice(1.50) <- apple yap "
+$eloc/abac_prover_yap  --keystore $keyloc --oset "$ralphs_apple" --object "[string:'apple']"
+
+
Index: examples/runall-fast
===================================================================
--- examples/runall-fast	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
+++ examples/runall-fast	(revision c586a3c974eed872c4a41b9c2f5f7db8484b0eef)
@@ -0,0 +1,8 @@
+#/bin/sh 
+
+for i in `ls -1 `; do
+   if (file $i | grep -F directory | grep -Fq typed); then
+       printf "\n ==> TRYING on %s\n" "$i"
+       (cd $i; rr; cd ..)
+   fi
+done
